#include "eigen.h"
#define RANDOM drand48()

/* normalize - normalize a given vector 'v' of given length 'length'.
   return the norm of v. */
scalar normalize(v,length)
	vector v;
	int length;
{
	double sqrt();
	scalar sum=0.0;
	int i;

	for(i=0;i<length;i++)
		sum+=v[i]*v[i];
	sum=sqrt(sum);
	for(i=0;i<length;i++)
		v[i]/=sum;
}

/* norm - find norm of a given vector 'v' of given length 'length' */
scalar norm(v,length)
	vector v;
	int length;
{
	scalar sum=0.0;
	int i;

	for(i=0;i<length;i++)
		sum+=v[i]*v[i];
	sum=sqrt(sum);
	return sum;
}

/* Vvsub - subtract two vectors, and put the result in (possibly one
   of the two) third vector
*/

vvsub(x1,x2,size,out)
        vector x1,x2,out;
{
        int i;

        for(i=0; i<size; i++)
                out[i]=x1[i]-x2[i];
}

/* Vvadd - add two vectors, and put the result in (possibly one
   of the two) third vector
*/

vvadd(x1,x2,size,out)
        vector x1,x2,out;
{
        int i;

        for(i=0; i<size; i++)
                out[i]=x1[i]+x2[i];
}

/* randomvec - generate a random vector of length 'length', and put it
   in 'v'.
 */
randomvec(v,length)
	vector v;
	int length;
{
	double RANDOM;
	while(length--)
		v[length]=RANDOM;
}
